
/* /////////////////////////////////////////////////////////////////////////////////////////////////
Basic VaM gamepad by Fabio.
Gamepad support for VaM.

Written in Notepad :p
	
Version 1.0 2021-02-11
	Initial release.

License: MIT.
	
///////////////////////////////////////////////////////////////////////////////////////////////// */


using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using UnityEngine.UI;
using UnityEngine.Events;
using UnityEngine.Animations;
using System.Linq;

public class VaMgamepad : MVRScript
{
	private int mode = 1;
	private bool changed = true;
	private bool changed2 = true;

	public override void Init()
	{
            ;
	}

	public void OnEnable()
	{
            ;
        }

	public void OnDisable()
	{
		;
	}

	public void OnDestroy()
	{
		;
	}

	public void ControllerMove(int dir, int up)
	{
		SuperController sc = SuperController.singleton;
		FreeControllerV3 controller = SuperController.singleton.GetSelectedController();
		if (controller == null) { return; }

               	var direction = Vector3.right;
    
		switch (dir)
       		{
      			case 1:
       				direction = Vector3.right;
       				break;
      			case 2:
       				direction = Vector3.up;
      				break;
      			case 3:
       				direction = Vector3.forward;
       				break;
       		}

            	controller.transform.Translate(direction * Time.deltaTime * 0.5f * up, Camera.main.transform); // Space.Self
	}

	public void ControllerRotate(int dir, int up)
	{
		SuperController sc = SuperController.singleton;
		FreeControllerV3 controller = SuperController.singleton.GetSelectedController();
		if (controller == null) { return; }

                var rotate = 360 * Time.deltaTime * 0.25f * up;
                var target = controller.transform;

                if(dir == 1) { target.RotateAround(target.transform.position, Camera.main.transform.right, -rotate); } //  target.Rotate(rotate, 0, 0); }
              	else if(dir == 2) { target.RotateAround(target.transform.position, Camera.main.transform.up, rotate); } //  target.Rotate(0, rotate, 0); }
             	else if(dir == 3) { target.RotateAround(target.transform.position, Camera.main.transform.forward, -rotate); } // target.Rotate(0, 0, rotate); }
	}

	public void CameraMove(int dir, int up)
	{
		Camera cam = CameraTarget.centerTarget.targetCamera;
		if (cam == null) { return; }

               	var direction = Vector3.right;
    
		switch (dir)
       		{
      			case 1:
       				direction = Vector3.right;
       				break;
      			case 2:
       				direction = Vector3.up;
      				break;
      			case 3:
       				direction = Vector3.forward;
       				break;
       		}

		cam.transform.Translate(direction * Time.deltaTime * 2.0f * up);
	}

	public void CameraRotate(int dir, int up)
	{
		Camera cam = CameraTarget.centerTarget.targetCamera;
		if (cam == null) { return; }

                var rotate = 360 * Time.deltaTime * 0.25f * up;
                var target = cam.transform;

                if(dir == 1) { target.Rotate(rotate, 0, 0); }
                else if(dir == 2) { target.Rotate(0, rotate, 0); }
                else if(dir == 3) { target.Rotate(0, 0, rotate); }
	}

	public void SelectController(bool next)
	{
		SuperController sc = SuperController.singleton;
		FreeControllerV3 current = SuperController.singleton.GetSelectedController();
		if (current == null) { return; }

		var cur = SuperController.singleton.GetSelectedAtom();
		if (cur == null) { return; }

		FreeControllerV3[] con = new FreeControllerV3[4];

		int count = 3;
		if (next == false) { count = 4; }

		if (next)
		{
			con[0] = cur.GetStorableByID("headControl") as FreeControllerV3;
			con[1] = cur.GetStorableByID("chestControl") as FreeControllerV3;
			con[2] = cur.GetStorableByID("hipControl") as FreeControllerV3;
			con[3] = cur.GetStorableByID("control") as FreeControllerV3;
		}
		else
		{
			con[0] = cur.GetStorableByID("rHandControl") as FreeControllerV3;
			con[1] = cur.GetStorableByID("lHandControl") as FreeControllerV3;
			con[2] = cur.GetStorableByID("rFootControl") as FreeControllerV3;
			con[3] = cur.GetStorableByID("lFootControl") as FreeControllerV3;
		}		

		FreeControllerV3 after = null;
		bool founded = false;

            	for(int i = 0; i < count; i++)
            	{
			if (founded) 
			{
				after = con[i];
				break;
			}
	
			if (con[i].name == current.name) { founded = true; }	
		}

		if (after) 
		{
			SuperController.singleton.SelectController(after);
		}
		else
		{
			SuperController.singleton.SelectController(con[0]);
		}
	}

	private void SelectCurrentPerson()
	{
		var cur = SuperController.singleton.GetSelectedAtom();
		if (cur == null) { return; }
		FreeControllerV3 after = cur.GetStorableByID("control") as FreeControllerV3;

		if (after) 
			SuperController.singleton.SelectController(after);
		else
			SelectNextPerson();
	}

	private void SelectNextPerson()
	{
		SuperController scs = SuperController.singleton;
		scs.CycleSelectAtomOfType("Person");
	}

	private void EditMode()
	{
		SuperController sc = SuperController.singleton;
		sc.gameMode = SuperController.GameMode.Edit;
		
		if (!sc.isOVR && !sc.isOpenVR)
		{
			sc.ShowMainHUDMonitor();
		}
	}

	private void ToggleUI()
	{
		SuperController scs = SuperController.singleton;
		scs.ToggleMonitorUI();
	}

	private void ToggleTargets()
	{
		SuperController scs = SuperController.singleton;
		scs.ToggleTargetsOnWithButton();
	}

	public void Update()
	{
		//------------------------------------------------------------------------------------------
		// LEFT STICK
		//------------------------------------------------------------------------------------------

		if ( Input.GetAxis("LeftStickX") <= -0.1f ) // LEFT STICK LEFT
		{
			switch (mode)
       			{
      				case 1: // camera
       					 CameraMove(1, -1); // move left
       					break;
      				case 2: // movement
       					ControllerMove(1, -1); // move left
      					break;
      				case 3: // rotation
       					ControllerRotate(2, 1); // turn left
       					break;
       			}
		}

		if ( Input.GetAxis("LeftStickX") >= 0.1f ) // LEFT STICK RIGHT
		{
			switch (mode)
       			{
      				case 1: // camera
       					 CameraMove(1, 1); // move right
       					break;
      				case 2: // movement
       					ControllerMove(1, 1); // move right
      					break;
      				case 3: // rotation
       					ControllerRotate(2, -1); // turn right
       					break;
       			}
		}

		if ( Input.GetAxis("LeftStickY") <= -0.1f ) // LEFT STICK UP
		{
			switch (mode)
       			{
      				case 1: // camera
       					 CameraMove(3, 1); // zoom in
       					break;
      				case 2: // movement
       					ControllerMove(2, 1); // move up
      					break;
      				case 3: // rotation
       					ControllerRotate(1, -1); // look up
       					break;
       			}
		}

		if ( Input.GetAxis("LeftStickY") >= 0.1f ) // LEFT STICK DOWN
		{
			switch (mode)
       			{
      				case 1: // camera
       					 CameraMove(3, -1); // zoom out
       					break;
      				case 2: // movement
       					ControllerMove(2, -1); // move down
      					break;
      				case 3: // rotation
       					ControllerRotate(1, 1); // look down
       					break;
       			}
		}

		//------------------------------------------------------------------------------------------
		// RIGHT STICK
		//------------------------------------------------------------------------------------------

		if ( Input.GetAxis("RightStickX") <= -0.1f ) // RIGHT STICK LEFT
		{
			switch (mode)
       			{
      				case 1: // camera
       					CameraRotate(2, -1); // turn left
       					break;
      				case 2: // movement
       					;
      					break;
      				case 3: // rotation
       					ControllerRotate(3, -1); // roll left
       					break;
       			}
		}

		if ( Input.GetAxis("RightStickX") >= 0.1f ) // RIGHT STICK RIGHT
		{
			switch (mode)
       			{
      				case 1: // camera
       					CameraRotate(2, 1); // turn right
       					break;
      				case 2: // movement
       					;
      					break;
      				case 3: // rotation
       					ControllerRotate(3, 1); // roll right
       					break;
       			}
		}

		if ( Input.GetAxis("RightStickY") <= -0.1f ) // RIGHT STICK UP
		{
			switch (mode)
       			{
      				case 1: // camera
       					CameraRotate(1, -1); // look up
       					break;
      				case 2: // movement
       					ControllerMove(3, 1); // zoom out
      					break;
      				case 3: // rotation
       					;
       					break;
       			}
		}

		if ( Input.GetAxis("RightStickY") >= 0.1f ) // RIGHT STICK DOWN
		{
			switch (mode)
       			{
      				case 1: // camera
       					CameraRotate(1, 1); // look down
       					break;
      				case 2: // movement
       					ControllerMove(3, -1); // zoom in
      					break;
      				case 3: // rotation
       					;
       					break;
       			}
		}

		//------------------------------------------------------------------------------------------
		// D-PAD
		//------------------------------------------------------------------------------------------

		if ( Input.GetAxis("Axis6") <= -0.1f ) // D-PAD LEFT
		{
			if (mode != 1) return;
			CameraRotate(3, 1); // roll left
		}

		if ( Input.GetAxis("Axis6") >= 0.1f ) // D-PAD RIGHT
		{
			if (mode != 1) return;
			CameraRotate(3, -1); // roll right
		}

		if ( Input.GetAxis("Axis7") >= 0.1f ) // D-PAD UP
		{
			if (mode != 1) return;
			CameraMove(2, 1); // move up
		}

		if ( Input.GetAxis("Axis7") <= -0.1f ) // D-PAD DOWN
		{
			if (mode != 1) return;
			CameraMove(2, -1); // move down
		}

		//------------------------------------------------------------------------------------------
		// ACTION BUTTONS
		//------------------------------------------------------------------------------------------

		if (Input.GetKeyDown("joystick button 0")) // A
		{
			SelectController(true);
		}

		if (Input.GetKeyDown("joystick button 1")) // B
		{
			
			SelectCurrentPerson();
		}

		if (Input.GetKeyDown("joystick button 2")) // X
		{
			SelectController(false);	
		}

		if (Input.GetKeyDown("joystick button 3")) // Y
		{
			SelectNextPerson();
		}

		//------------------------------------------------------------------------------------------
		// TRIGGERS
		//------------------------------------------------------------------------------------------

		if (Input.GetKeyDown("joystick button 4")) // LB
		{
			mode = 1; // camera mode
		}

		if (Input.GetKeyDown("joystick button 5")) // RB
		{
			mode = 2; // position mode
		}

		bool useLT = false;

		if ( Input.GetAxis("Triggers") <= -0.1f ) // LT
		{
			useLT = true;
		}

		if (useLT == true && changed == true)
		{
			ToggleTargets(); // show / hide controllers
			changed = false;
		}
		if (useLT == false) { changed = true; }

		bool useRT = false;

		if ( Input.GetAxis("Triggers") >= 0.1f ) // RT
		{
			useRT = true;
		}

		if (useRT == true && changed2 == true)
		{
			mode = 3; // rotation mode
			changed2 = false;
		}
		if (useRT == false) { changed2 = true; }

		//------------------------------------------------------------------------------------------
		// START - SELECT
		//------------------------------------------------------------------------------------------

		if (Input.GetKeyDown("joystick button 6")) // SELECT
		{
			EditMode();
		}

		if ( Input.GetKeyDown("joystick button 7") ) // START
		{
			ToggleUI();
		}

	}
}
